/* SettingsOption.c generated by valac 0.56.14, the Vala compiler
 * generated from SettingsOption.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "notifications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <float.h>
#include <math.h>

enum  {
	WIDGETS_SETTINGS_OPTION_0_PROPERTY,
	WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY,
	WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY,
	WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY,
	WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY,
	WIDGETS_SETTINGS_OPTION_NUM_PROPERTIES
};
static GParamSpec* widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _WidgetsSettingsOptionPrivate {
	gchar* _image_path;
	gchar* _title;
	gchar* _description;
	GtkWidget* _widget;
	GtkImage* image;
	GtkSettings* gtk_settings;
};

static gint WidgetsSettingsOption_private_offset;
static gpointer widgets_settings_option_parent_class = NULL;
static GtkCssProvider* widgets_settings_option_css_provider;
static GtkCssProvider* widgets_settings_option_css_provider = NULL;

static void widgets_settings_option_update_image_resource (WidgetsSettingsOption* self);
static GObject * widgets_settings_option_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _widgets_settings_option___lambda6_ (WidgetsSettingsOption* self);
static void __widgets_settings_option___lambda6__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void widgets_settings_option_finalize (GObject * obj);
static GType widgets_settings_option_get_type_once (void);
static void _vala_widgets_settings_option_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_widgets_settings_option_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
widgets_settings_option_get_instance_private (WidgetsSettingsOption* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsSettingsOption_private_offset);
}

WidgetsSettingsOption*
widgets_settings_option_construct (GType object_type,
                                   const gchar* image_path,
                                   const gchar* title,
                                   const gchar* description,
                                   GtkWidget* widget)
{
	WidgetsSettingsOption * self = NULL;
#line 31 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (image_path != NULL, NULL);
#line 31 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 31 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 31 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 32 "../src/Widgets/SettingsOption.vala"
	self = (WidgetsSettingsOption*) g_object_new (object_type, "image-path", image_path, "title", title, "description", description, "widget", widget, NULL);
#line 31 "../src/Widgets/SettingsOption.vala"
	return self;
#line 112 "SettingsOption.c"
}

WidgetsSettingsOption*
widgets_settings_option_new (const gchar* image_path,
                             const gchar* title,
                             const gchar* description,
                             GtkWidget* widget)
{
#line 31 "../src/Widgets/SettingsOption.vala"
	return widgets_settings_option_construct (WIDGETS_TYPE_SETTINGS_OPTION, image_path, title, description, widget);
#line 123 "SettingsOption.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 145 "SettingsOption.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 149 "SettingsOption.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 155 "SettingsOption.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 159 "SettingsOption.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 163 "SettingsOption.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 171 "SettingsOption.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 199 "SettingsOption.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 208 "SettingsOption.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 222 "SettingsOption.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 231 "SettingsOption.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 245 "SettingsOption.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 254 "SettingsOption.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 263 "SettingsOption.c"
}

static void
widgets_settings_option_update_image_resource (WidgetsSettingsOption* self)
{
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 97 "../src/Widgets/SettingsOption.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->gtk_settings;
#line 98 "../src/Widgets/SettingsOption.vala"
	g_object_get (_tmp0_, "gtk-application-prefer-dark-theme", &_tmp1_, NULL);
#line 98 "../src/Widgets/SettingsOption.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/Widgets/SettingsOption.vala"
	if (_tmp2_) {
#line 282 "SettingsOption.c"
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 99 "../src/Widgets/SettingsOption.vala"
		_tmp3_ = self->priv->image;
#line 99 "../src/Widgets/SettingsOption.vala"
		_tmp4_ = self->priv->_image_path;
#line 99 "../src/Widgets/SettingsOption.vala"
		_tmp5_ = string_replace (_tmp4_, ".svg", "-dark.svg");
#line 99 "../src/Widgets/SettingsOption.vala"
		_tmp6_ = _tmp5_;
#line 99 "../src/Widgets/SettingsOption.vala"
		g_object_set (_tmp3_, "resource", _tmp6_, NULL);
#line 99 "../src/Widgets/SettingsOption.vala"
		_g_free0 (_tmp6_);
#line 299 "SettingsOption.c"
	} else {
		GtkImage* _tmp7_;
		const gchar* _tmp8_;
#line 101 "../src/Widgets/SettingsOption.vala"
		_tmp7_ = self->priv->image;
#line 101 "../src/Widgets/SettingsOption.vala"
		_tmp8_ = self->priv->_image_path;
#line 101 "../src/Widgets/SettingsOption.vala"
		g_object_set (_tmp7_, "resource", _tmp8_, NULL);
#line 309 "SettingsOption.c"
	}
}

const gchar*
widgets_settings_option_get_image_path (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 21 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->_image_path;
#line 21 "../src/Widgets/SettingsOption.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/SettingsOption.vala"
	return result;
#line 326 "SettingsOption.c"
}

static void
widgets_settings_option_set_image_path (WidgetsSettingsOption* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 21 "../src/Widgets/SettingsOption.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/SettingsOption.vala"
	old_value = widgets_settings_option_get_image_path (self);
#line 21 "../src/Widgets/SettingsOption.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 340 "SettingsOption.c"
		gchar* _tmp0_;
#line 21 "../src/Widgets/SettingsOption.vala"
		_tmp0_ = g_strdup (value);
#line 21 "../src/Widgets/SettingsOption.vala"
		_g_free0 (self->priv->_image_path);
#line 21 "../src/Widgets/SettingsOption.vala"
		self->priv->_image_path = _tmp0_;
#line 21 "../src/Widgets/SettingsOption.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY]);
#line 350 "SettingsOption.c"
	}
}

const gchar*
widgets_settings_option_get_title (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->_title;
#line 22 "../src/Widgets/SettingsOption.vala"
	result = _tmp0_;
#line 22 "../src/Widgets/SettingsOption.vala"
	return result;
#line 367 "SettingsOption.c"
}

static void
widgets_settings_option_set_title (WidgetsSettingsOption* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 22 "../src/Widgets/SettingsOption.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/SettingsOption.vala"
	old_value = widgets_settings_option_get_title (self);
#line 22 "../src/Widgets/SettingsOption.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 381 "SettingsOption.c"
		gchar* _tmp0_;
#line 22 "../src/Widgets/SettingsOption.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../src/Widgets/SettingsOption.vala"
		_g_free0 (self->priv->_title);
#line 22 "../src/Widgets/SettingsOption.vala"
		self->priv->_title = _tmp0_;
#line 22 "../src/Widgets/SettingsOption.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY]);
#line 391 "SettingsOption.c"
	}
}

const gchar*
widgets_settings_option_get_description (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->_description;
#line 23 "../src/Widgets/SettingsOption.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/SettingsOption.vala"
	return result;
#line 408 "SettingsOption.c"
}

static void
widgets_settings_option_set_description (WidgetsSettingsOption* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 23 "../src/Widgets/SettingsOption.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/SettingsOption.vala"
	old_value = widgets_settings_option_get_description (self);
#line 23 "../src/Widgets/SettingsOption.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 422 "SettingsOption.c"
		gchar* _tmp0_;
#line 23 "../src/Widgets/SettingsOption.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Widgets/SettingsOption.vala"
		_g_free0 (self->priv->_description);
#line 23 "../src/Widgets/SettingsOption.vala"
		self->priv->_description = _tmp0_;
#line 23 "../src/Widgets/SettingsOption.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY]);
#line 432 "SettingsOption.c"
	}
}

GtkWidget*
widgets_settings_option_get_widget (WidgetsSettingsOption* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 24 "../src/Widgets/SettingsOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->_widget;
#line 24 "../src/Widgets/SettingsOption.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/SettingsOption.vala"
	return result;
#line 449 "SettingsOption.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/Widgets/SettingsOption.vala"
	return self ? g_object_ref (self) : NULL;
#line 457 "SettingsOption.c"
}

static void
widgets_settings_option_set_widget (WidgetsSettingsOption* self,
                                    GtkWidget* value)
{
	GtkWidget* old_value;
#line 24 "../src/Widgets/SettingsOption.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/SettingsOption.vala"
	old_value = widgets_settings_option_get_widget (self);
#line 24 "../src/Widgets/SettingsOption.vala"
	if (old_value != value) {
#line 471 "SettingsOption.c"
		GtkWidget* _tmp0_;
#line 24 "../src/Widgets/SettingsOption.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/SettingsOption.vala"
		_g_object_unref0 (self->priv->_widget);
#line 24 "../src/Widgets/SettingsOption.vala"
		self->priv->_widget = _tmp0_;
#line 24 "../src/Widgets/SettingsOption.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY]);
#line 481 "SettingsOption.c"
	}
}

static void
_widgets_settings_option___lambda6_ (WidgetsSettingsOption* self)
{
#line 91 "../src/Widgets/SettingsOption.vala"
	widgets_settings_option_update_image_resource (self);
#line 490 "SettingsOption.c"
}

static void
__widgets_settings_option___lambda6__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 90 "../src/Widgets/SettingsOption.vala"
	_widgets_settings_option___lambda6_ ((WidgetsSettingsOption*) self);
#line 500 "SettingsOption.c"
}

static GObject *
widgets_settings_option_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsSettingsOption * self;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkGrid* card = NULL;
	GtkGrid* _tmp2_ = NULL;
	GtkGrid* _tmp3_;
	GtkImage* _tmp4_;
	GtkStyleContext* card_context = NULL;
	GtkGrid* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkLabel* title_label = NULL;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	GtkLabel* description_label = NULL;
	const gchar* _tmp19_;
	GtkLabel* _tmp20_ = NULL;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkWidget* _tmp23_;
	GtkLabel* _tmp24_;
	GtkSettings* _tmp25_;
	GtkSettings* _tmp26_;
	GtkSettings* _tmp27_;
#line 45 "../src/Widgets/SettingsOption.vala"
	parent_class = G_OBJECT_CLASS (widgets_settings_option_parent_class);
#line 45 "../src/Widgets/SettingsOption.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../src/Widgets/SettingsOption.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
#line 46 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = self->priv->_image_path;
#line 46 "../src/Widgets/SettingsOption.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_resource (_tmp0_);
#line 46 "../src/Widgets/SettingsOption.vala"
	g_object_ref_sink (_tmp1_);
#line 46 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (self->priv->image);
#line 46 "../src/Widgets/SettingsOption.vala"
	self->priv->image = _tmp1_;
#line 48 "../src/Widgets/SettingsOption.vala"
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
#line 48 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_START);
#line 48 "../src/Widgets/SettingsOption.vala"
	g_object_ref_sink (_tmp2_);
#line 48 "../src/Widgets/SettingsOption.vala"
	card = _tmp2_;
#line 51 "../src/Widgets/SettingsOption.vala"
	_tmp3_ = card;
#line 51 "../src/Widgets/SettingsOption.vala"
	_tmp4_ = self->priv->image;
#line 51 "../src/Widgets/SettingsOption.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 53 "../src/Widgets/SettingsOption.vala"
	_tmp5_ = card;
#line 53 "../src/Widgets/SettingsOption.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 53 "../src/Widgets/SettingsOption.vala"
	card_context = _tmp6_;
#line 54 "../src/Widgets/SettingsOption.vala"
	_tmp7_ = card_context;
#line 54 "../src/Widgets/SettingsOption.vala"
	gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_CARD);
#line 55 "../src/Widgets/SettingsOption.vala"
	_tmp8_ = card_context;
#line 55 "../src/Widgets/SettingsOption.vala"
	gtk_style_context_add_class (_tmp8_, GRANITE_STYLE_CLASS_ROUNDED);
#line 56 "../src/Widgets/SettingsOption.vala"
	_tmp9_ = card_context;
#line 56 "../src/Widgets/SettingsOption.vala"
	_tmp10_ = widgets_settings_option_css_provider;
#line 56 "../src/Widgets/SettingsOption.vala"
	gtk_style_context_add_provider (_tmp9_, (GtkStyleProvider*) _tmp10_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 58 "../src/Widgets/SettingsOption.vala"
	_tmp11_ = self->priv->_title;
#line 58 "../src/Widgets/SettingsOption.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (_tmp11_);
#line 58 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
#line 58 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
#line 58 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 58 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp12_, FALSE);
#line 58 "../src/Widgets/SettingsOption.vala"
	g_object_ref_sink (_tmp12_);
#line 58 "../src/Widgets/SettingsOption.vala"
	title_label = _tmp12_;
#line 64 "../src/Widgets/SettingsOption.vala"
	_tmp13_ = title_label;
#line 64 "../src/Widgets/SettingsOption.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 64 "../src/Widgets/SettingsOption.vala"
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 66 "../src/Widgets/SettingsOption.vala"
	_tmp15_ = self->priv->_widget;
#line 66 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_halign (_tmp15_, GTK_ALIGN_START);
#line 67 "../src/Widgets/SettingsOption.vala"
	_tmp16_ = self->priv->_widget;
#line 67 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_valign (_tmp16_, GTK_ALIGN_CENTER);
#line 68 "../src/Widgets/SettingsOption.vala"
	_tmp17_ = self->priv->_widget;
#line 68 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_hexpand (_tmp17_, FALSE);
#line 69 "../src/Widgets/SettingsOption.vala"
	_tmp18_ = self->priv->_widget;
#line 69 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_vexpand (_tmp18_, FALSE);
#line 71 "../src/Widgets/SettingsOption.vala"
	_tmp19_ = self->priv->_description;
#line 71 "../src/Widgets/SettingsOption.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_tmp19_);
#line 71 "../src/Widgets/SettingsOption.vala"
	gtk_label_set_xalign (_tmp20_, (gfloat) 0);
#line 71 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
#line 71 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp20_, TRUE);
#line 71 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp20_, FALSE);
#line 71 "../src/Widgets/SettingsOption.vala"
	g_object_set (_tmp20_, "wrap", TRUE, NULL);
#line 71 "../src/Widgets/SettingsOption.vala"
	gtk_label_set_justify (_tmp20_, GTK_JUSTIFY_LEFT);
#line 71 "../src/Widgets/SettingsOption.vala"
	g_object_ref_sink (_tmp20_);
#line 71 "../src/Widgets/SettingsOption.vala"
	description_label = _tmp20_;
#line 80 "../src/Widgets/SettingsOption.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 81 "../src/Widgets/SettingsOption.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 82 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 60);
#line 83 "../src/Widgets/SettingsOption.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 30);
#line 84 "../src/Widgets/SettingsOption.vala"
	_tmp21_ = card;
#line 84 "../src/Widgets/SettingsOption.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp21_, 0, 0, 1, 3);
#line 85 "../src/Widgets/SettingsOption.vala"
	_tmp22_ = title_label;
#line 85 "../src/Widgets/SettingsOption.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 1, 0, 1, 1);
#line 86 "../src/Widgets/SettingsOption.vala"
	_tmp23_ = self->priv->_widget;
#line 86 "../src/Widgets/SettingsOption.vala"
	gtk_grid_attach ((GtkGrid*) self, _tmp23_, 1, 1, 1, 1);
#line 87 "../src/Widgets/SettingsOption.vala"
	_tmp24_ = description_label;
#line 87 "../src/Widgets/SettingsOption.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp24_, 1, 2, 1, 1);
#line 89 "../src/Widgets/SettingsOption.vala"
	_tmp25_ = gtk_settings_get_default ();
#line 89 "../src/Widgets/SettingsOption.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 89 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (self->priv->gtk_settings);
#line 89 "../src/Widgets/SettingsOption.vala"
	self->priv->gtk_settings = _tmp26_;
#line 90 "../src/Widgets/SettingsOption.vala"
	_tmp27_ = self->priv->gtk_settings;
#line 90 "../src/Widgets/SettingsOption.vala"
	g_signal_connect_object ((GObject*) _tmp27_, "notify::gtk-application-prefer-dark-theme", (GCallback) __widgets_settings_option___lambda6__g_object_notify, self, 0);
#line 94 "../src/Widgets/SettingsOption.vala"
	widgets_settings_option_update_image_resource (self);
#line 45 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (description_label);
#line 45 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (title_label);
#line 45 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (card);
#line 45 "../src/Widgets/SettingsOption.vala"
	return obj;
#line 697 "SettingsOption.c"
}

static void
widgets_settings_option_class_init (WidgetsSettingsOptionClass * klass,
                                    gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 20 "../src/Widgets/SettingsOption.vala"
	widgets_settings_option_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/SettingsOption.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsSettingsOption_private_offset);
#line 20 "../src/Widgets/SettingsOption.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_settings_option_get_property;
#line 20 "../src/Widgets/SettingsOption.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_settings_option_set_property;
#line 20 "../src/Widgets/SettingsOption.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_settings_option_constructor;
#line 20 "../src/Widgets/SettingsOption.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_settings_option_finalize;
#line 20 "../src/Widgets/SettingsOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY] = g_param_spec_string ("image-path", "image-path", "image-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/SettingsOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/SettingsOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Widgets/SettingsOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/Widgets/SettingsOption.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 41 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (widgets_settings_option_css_provider);
#line 41 "../src/Widgets/SettingsOption.vala"
	widgets_settings_option_css_provider = _tmp0_;
#line 42 "../src/Widgets/SettingsOption.vala"
	_tmp1_ = widgets_settings_option_css_provider;
#line 42 "../src/Widgets/SettingsOption.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/switchboard/SettingsOption.css");
#line 736 "SettingsOption.c"
}

static void
widgets_settings_option_instance_init (WidgetsSettingsOption * self,
                                       gpointer klass)
{
#line 20 "../src/Widgets/SettingsOption.vala"
	self->priv = widgets_settings_option_get_instance_private (self);
#line 745 "SettingsOption.c"
}

static void
widgets_settings_option_finalize (GObject * obj)
{
	WidgetsSettingsOption * self;
#line 20 "../src/Widgets/SettingsOption.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
#line 21 "../src/Widgets/SettingsOption.vala"
	_g_free0 (self->priv->_image_path);
#line 22 "../src/Widgets/SettingsOption.vala"
	_g_free0 (self->priv->_title);
#line 23 "../src/Widgets/SettingsOption.vala"
	_g_free0 (self->priv->_description);
#line 24 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (self->priv->_widget);
#line 28 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (self->priv->image);
#line 29 "../src/Widgets/SettingsOption.vala"
	_g_object_unref0 (self->priv->gtk_settings);
#line 20 "../src/Widgets/SettingsOption.vala"
	G_OBJECT_CLASS (widgets_settings_option_parent_class)->finalize (obj);
#line 768 "SettingsOption.c"
}

static GType
widgets_settings_option_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsSettingsOptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_settings_option_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsSettingsOption), 0, (GInstanceInitFunc) widgets_settings_option_instance_init, NULL };
	GType widgets_settings_option_type_id;
	widgets_settings_option_type_id = g_type_register_static (gtk_grid_get_type (), "WidgetsSettingsOption", &g_define_type_info, 0);
	WidgetsSettingsOption_private_offset = g_type_add_instance_private (widgets_settings_option_type_id, sizeof (WidgetsSettingsOptionPrivate));
	return widgets_settings_option_type_id;
}

GType
widgets_settings_option_get_type (void)
{
	static volatile gsize widgets_settings_option_type_id__once = 0;
	if (g_once_init_enter (&widgets_settings_option_type_id__once)) {
		GType widgets_settings_option_type_id;
		widgets_settings_option_type_id = widgets_settings_option_get_type_once ();
		g_once_init_leave (&widgets_settings_option_type_id__once, widgets_settings_option_type_id);
	}
	return widgets_settings_option_type_id__once;
}

static void
_vala_widgets_settings_option_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsSettingsOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
#line 20 "../src/Widgets/SettingsOption.vala"
	switch (property_id) {
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		g_value_set_string (value, widgets_settings_option_get_image_path (self));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		g_value_set_string (value, widgets_settings_option_get_title (self));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		g_value_set_string (value, widgets_settings_option_get_description (self));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		g_value_set_object (value, widgets_settings_option_get_widget (self));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 827 "SettingsOption.c"
		default:
#line 20 "../src/Widgets/SettingsOption.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 833 "SettingsOption.c"
	}
}

static void
_vala_widgets_settings_option_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsSettingsOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
#line 20 "../src/Widgets/SettingsOption.vala"
	switch (property_id) {
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		widgets_settings_option_set_image_path (self, g_value_get_string (value));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		widgets_settings_option_set_title (self, g_value_get_string (value));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		widgets_settings_option_set_description (self, g_value_get_string (value));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 20 "../src/Widgets/SettingsOption.vala"
		case WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY:
#line 20 "../src/Widgets/SettingsOption.vala"
		widgets_settings_option_set_widget (self, g_value_get_object (value));
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 871 "SettingsOption.c"
		default:
#line 20 "../src/Widgets/SettingsOption.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/SettingsOption.vala"
		break;
#line 877 "SettingsOption.c"
	}
}

